const express = require("express");
const router = express.Router();
const ErrorHandler = require("../utils/ErrorHandler");
const catchAsyncErrors = require("../middleware/catchAsyncErrors");
const { isAuthenticated, isSeller, isAdmin } = require("../middleware/auth");
const Order = require("../model/order");
const Shop = require("../model/shop");
const Product = require("../model/product");
const axios = require('axios');
const order = require("../model/order");
const cron = require('node-cron');
const moment = require('moment');
const product = require("../model/product");
const razorpay_api=require("razorpay");
//import dotenv from 'dotenv';
const dotenv=require('../config/.env')
const SibApiV3Sdk=require('sib-api-v3-sdk');
const generateShipRocketToken =require('../utils/generateShipRocketToken');



//const getShiprocketAuthToken=require("../utils/generateShipRocketToken")
//dotenv.config();

const apiKey = process.env.APIKEY;
console.log("the api key is",apiKey)
const apiSecret = process.env.APISECRET;
console.log("the secret is",apiSecret);
console.log("the brevo email key is",process.env.MAILAPIKEY);



// create new order
router.post(
  "/create-order", 
  catchAsyncErrors(async (req, res, next) => {
    try {
      const { cart, shippingAddress, user, totalPrice, paymentInfo } = req.body;
      //console.log("the cart is",cart);
      //console.log("the productId for the product in the cart is",cart[0].productId);
      const pickup=await product.findById({_id:cart[0].productId}).select('pickup_location shop name');
      const pickup_location=pickup.pickup_location;
      const sellername=pickup.shop.name;
      const selleremail=pickup.shop.email;
      const productName=pickup.name;
      console.log("the pickup_location is",pickup_location);
      //console.log("the address_of_product is",address_of_product);

      console.log("the user is",user);
      console.log("the user name is",user.name);

      // group cart items by shopId
      const shopItemsMap = new Map();

      //fetch the token data from here
      const token=await generateShipRocketToken();
      
      
      const create_new_order=`https://apiv2.shiprocket.in/v1/external/orders/create/adhoc`;
 

// Billing details
const billing_customer_name = user.name;
const billing_address = shippingAddress.address1;
const billing_city = shippingAddress.city;
const billing_pincode = shippingAddress.zipCode;
const billing_state = shippingAddress.state;
const billing_country = shippingAddress.country;
const billing_email = user.email;
const billing_phone = user.phone;

async function sendEmailToseller( productName, sellerEmail,sellername) {
  var defaultClient = SibApiV3Sdk.ApiClient.instance;
  // Configure API key authorization: api-key
  var apiKey = defaultClient.authentications['api-key'];
  console.log("the api key is", apiKey)
  apiKey.apiKey = process.env.MAILAPIKEY;
  // console.log("the api key after this is", apiKey)
  // Uncomment below two lines to configure authorization using: partner-key
  // var partnerKey = defaultClient.authentications['partner-key'];
  
  // partnerKey.apiKey = 'YOUR API KEY';
  var apiInstance = new SibApiV3Sdk.TransactionalEmailsApi();
  var adminMail = new SibApiV3Sdk.SendSmtpEmail();
  const getIndianTime = () => {
      return new Date().toLocaleTimeString('en-IN', { 
          timeZone: 'Asia/Kolkata', 
          hour: '2-digit', 
          minute: '2-digit', 
          second: '2-digit', 
          hour12: false 
      });
  };

  try {

      adminMail = {
          to: [
              
                 { email: sellerEmail},
                 { email: 'gyanaranjan@ajatus.co.in'}
                //  { email: 'omprakash.sadangi@ajatus.co.in'},
                  
              
          ],
          from: {
              email: 'support@ceibagreen.com'
          },
          templateId: 30,
          params: {
              // parameter: 'recycle_pay',
              // subject: `Item updated ${itemName}`,
              // body: `Item updated ${itemName} from ${previousPrice} to ${updatedPrice}`,
              // date: new Date().toLocaleDateString(),
              // time: getIndianTime(),
              product_name: productName,
              customer_name: sellername
          },
          subject: `Product Sold ${productName}`,
          headers: {
              'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
          },
      }
      const data = await apiInstance.sendTransacEmail(adminMail);
      console.log("mail send successfully", data.messageId);
      console.log(productName)
  } catch (error) {
      console.log(error);
  }
}
//email to send user after order placed successfully
async function sendEmailToBuyer(order_item_name, billing_email,billing_customer_name,shippingAddress) {
  var defaultClient = SibApiV3Sdk.ApiClient.instance;
  // Configure API key authorization: api-key
  var apiKey = defaultClient.authentications['api-key'];
  console.log("the api key is", apiKey)
  apiKey.apiKey = process.env.MAILAPIKEY;
  // console.log("the api key after this is", apiKey)
  // Uncomment below two lines to configure authorization using: partner-key
  // var partnerKey = defaultClient.authentications['partner-key'];
  // partnerKey.apiKey = 'YOUR API KEY';
  var apiInstance = new SibApiV3Sdk.TransactionalEmailsApi();
  var adminMail = new SibApiV3Sdk.SendSmtpEmail();
  const getIndianTime = () => {
      return new Date().toLocaleTimeString('en-IN', { 
          timeZone: 'Asia/Kolkata', 
          hour: '2-digit', 
          minute: '2-digit', 
          second: '2-digit', 
          hour12: false 
      });
  };

  try {

      adminMail = {
          to: [
              
                 { email: billing_email},
                 { email: 'gyanaranjan@ajatus.co.in'}
                //  { email: 'omprakash.sadangi@ajatus.co.in'},
                  
              
          ],
          from: {
              email: 'support@ceibagreen.com'
          },
          templateId: 31,
          params: {
              // parameter: 'recycle_pay',
              // subject: `Item updated ${itemName}`,
              // body: `Item updated ${itemName} from ${previousPrice} to ${updatedPrice}`,
              // date: new Date().toLocaleDateString(),
              // time: getIndianTime(),
              product_name: order_item_name,
              customer_name: billing_customer_name,
              shipping_address:shippingAddress
          },
          subject: `Order placed ${order_item_name}`,
          headers: {
              'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
          },
      }
      const data = await apiInstance.sendTransacEmail(adminMail);
      console.log("mail send successfully", data.messageId);
      console.log(productName)
  } catch (error) {
      console.log(error);
  }
}
// Order items

const order_items=cart;
console.log("the order item is",order_items);
const order_item_name = order_items[0].name;
console.log("the order_item_name is")
const order_item_sku = "12345";
const order_item_units = order_items[0].quantity;
const order_item_selling_price = order_items[0].price ;
// Payment details
const payment_method = "Prepaid";
const sub_total = order_items[0].price;
console.log("the sub_total is",sub_total);

// Package dimensions
const length = 20;
const breadth = 20;
const height = 20;
const weight = 0.4;
//function to generate a random order_id
function generateRandomSixDigitNumber() {
  return Math.floor(100000 + Math.random() * 900000);
}
var order_id= generateRandomSixDigitNumber().toString();
//function to generate current date
function generateDateYYYYMMDD() {
  const date = new Date();
  const year = date.getFullYear();
  const month = String(date.getMonth() + 1).padStart(2, '0'); 
  const day = String(date.getDate()).padStart(2, '0');

  return `${year}-${month}-${day}`;
}
console.log(generateDateYYYYMMDD());  
var order_date=generateDateYYYYMMDD().toString();


const params = {
  order_id: order_id,
  order_date: order_date,
  pickup_location,
  billing_customer_name,
  "billing_last_name":"",
  billing_address,
  billing_city,
  billing_pincode,
  billing_state,
  billing_country,
  billing_email,
  billing_phone,
  shipping_is_billing: true,
  order_items:[
    {
      name:order_item_name,
      sku:order_item_sku,
      units:order_item_units,
      selling_price:order_item_selling_price,
      "discount": 0,
      "tax": 0,
      "hsn": 1
    }
  ],
  payment_method,
  sub_total,
  length,
  breadth,
  height,
  weight
};
console.log(params);
//this will be comment out later for testing purpose we have not 

const response2 = await axios.post(create_new_order,params,{
  
  headers: {
      'Content-Type': 'application/json',
      'Authorization': `Bearer ${token}`
  } 
});
console.log("the create order api of the shiprocket is",response2.data);



      for (const item of cart) {
        const shopId = item.shopId;
        if (!shopItemsMap.has(shopId)) {
          shopItemsMap.set(shopId, []);
        }
        shopItemsMap.get(shopId).push(item);
      }

      // create an order for each shop
      const orders = [];

      for (const [shopId, items] of shopItemsMap) {
        const order = await Order.create({
          cart: items,
          shipment_id:response2.data.shipment_id,
          //courier_order_id:response2.response2.data,
          shippingAddress,
          user,
          totalPrice,
          paymentInfo,
        });
        orders.push(order);
      }
      console.log("the order details is",orders);
       await sendEmailToseller(productName,selleremail,sellername);
       await sendEmailToBuyer(order_item_name, billing_email,billing_customer_name,billing_address);


      res.status(201).json({
        success: true,
        orderData: orders,
      });
    } catch (error) {
      console.log("Error:", error);
      return next(new ErrorHandler(error.message, 500));
    }
  })
);
//api for update the status after the payment successful
router.put(
  "/change-order-status/:orderId",
  catchAsyncErrors(async (req, res, next) => {
    try {
     const {orderId}=req.params;
     const status=req.body.status;
     console.log("the orderId coming from the frontend is",orderId);
     const order = await Order.findById(orderId);
     console.log("the order is",order);
     order.status=status;
     await order.save();
      res.status(200).json({
        success: true,
        order,
        message: "oder status changed successfully!",
      });
    } catch (error) {
      return next(new ErrorHandler(error.message, 500));
    }
  })
);

//api for change the stock after the product sold successfully
router.put(
  "/change-stock/:orderId",
  catchAsyncErrors(async (req, res, next) => {
    try {
     const {orderId}=req.params;
     console.log("the orderId coming from the frontend is",orderId);
     const order = await Order.findById(orderId);
     const productId=order.cart[0].productId;
     const product=await Product.findById({_id:productId});
     console.log("the product detsild is",product);
     //if the product stock is not equal to zero then only the stock will be decreased if the stock is already zero then nothing will happen
     if(product.stock!=0){
     const stock=product.stock;
     const updatestock=stock-1;
     product.stock=updatestock;
     await product.save();
     }
     
      res.status(200).json({
        success: true,
        product,
        message: "stock updated successfully!",
      });
    } catch (error) {
      return next(new ErrorHandler(error.message, 500));
    }
  })
);



//testing api for check the create order api firing or not
router.post(
  "/createpayment/:orderId",
  catchAsyncErrors(async (req, res, next) => {
    try {
      // Fetch the orderId from the path parameter
      const { orderId } = req.params;
      const order_details = await Order.findById({ _id: orderId });

      if (!order_details) {
        return next(new ErrorHandler("Order not found", 404));
      }

      console.log("The details only is", order_details);

      // Multiply the totalPrice by 100 and round it to avoid floating-point errors
      const amount = Math.round(order_details.totalPrice * 100);

      console.log("The amount from the order details is", order_details.totalPrice);
      console.log("The amount is", amount);

      const razorpay = new razorpay_api({
        key_id: apiKey,
        key_secret: apiSecret,
      });

      const order = await razorpay.orders.create({
        amount: amount, // Use the rounded integer amount
        currency: "INR",
        receipt: "No receipt",
        notes: {
          key1: "value3",
          key2: "value2",
        },
      });

      if (order) {
        res.send(order);
      }
    } catch (error) {
      console.log(error);
      return next(new ErrorHandler(error.message, 500));
    }
  })
);

// get all orders of user
router.get(
  "/get-all-orders/:userId",
  catchAsyncErrors(async (req, res, next) => {
    try {
      const orders = await Order.aggregate([
        {
          $match: { "user.userId": req.params.userId }, // Match orders by userId
        },
        {
          $sort: { createdAt: -1 }, // Sort orders by createdAt in descending order
        },
        {
          $unwind: "$cart", // Unwind the cart array to process each product separately
        },
        {
          $addFields: {
            // Convert productId in cart to ObjectId for matching
            "cart.productId": { $toObjectId: "$cart.productId" },
          },
        },
        {
          $lookup: {
            from: "products", // The product collection name
            localField: "cart.productId", // Field in the Order collection
            foreignField: "_id", // Field in the Product collection
            as: "cart.productDetails", // Resulting field that holds the product details
          },
        },
        {
          $unwind: {
            path: "$cart.productDetails",
            preserveNullAndEmptyArrays: true, // Include orders even if product details are missing
          },
        },
        {
          $group: {
            _id: "$_id", // Group by order ID to reconstruct the orders
            user: { $first: "$user" },
            shippingAddress: { $first: "$shippingAddress" },
            totalPrice: { $first: "$totalPrice" },
            status: { $first: "$status" },
            createdAt: { $first: "$createdAt" },
            shipment_status: { $first: "$shipment_status" },
            cart: {
              $push: {
                productId: "$cart.productId",
                name: "$cart.name",
                quantity: "$cart.quantity",
                price: "$cart.price",
                totalPrice: "$cart.totalPrice",
                shopId: "$cart.shopId",
                productDetails: "$cart.productDetails", // Include product details
              },
            },
          },
        },
        {
          $project: {
            user: 1,
            shippingAddress: 1,
            totalPrice: 1,
            status: 1,
            createdAt: 1,
            shipment_status: 1,
            cart: {
              productId: 1,
              name: 1,
              quantity: 1,
              price: 1,
              totalPrice: 1,
              shopId: 1,
              "productDetails.name": 1,
              "productDetails.description": 1,
              "productDetails.category": 1,
              "productDetails.images": 1, // Ensure images are included
            },
          },
        },
      ]);

      res.status(200).json({
        success: true,
        orders,
      });
    } catch (error) {
      return next(new ErrorHandler(error.message, 500));
    }
  })
);

//api for get all the order details by the orderId
router.get(
  "/get-order-details/:orderId",
  catchAsyncErrors(async (req, res, next) => {
    try {
      const orders = await Order.find({_id:req.params.orderId});
      const productId=orders[0].cart[0].productId;
      const productDetails = await Product.findById({_id:productId});
      res.status(200).json({
        success: true,
        orders,
        productDetails
      });
    } catch (error) {
      return next(new ErrorHandler(error.message, 500));
    }
  })
);
//api to get all order of the user by id and count total orders pending orders and completed orders
router.get(
  "/get-order-data/:userId",
  catchAsyncErrors(async (req, res, next) => {
    try {
      // Fetch orders for the given userId
      const orders = await Order.find({ 'user.userId': req.params.userId });
      console.log("The orders are", orders);

      // Count total orders
      const totalOrders = orders.length;

      // Count orders where payment is successful
      const paymentSuccessfulOrders = orders.filter(
        (order) => order.status === "payment successful"
      ).length;

      // Count orders where shipment status is "Delivered"
      const deliveredOrders = orders.filter(
        (order) => order.shipment_status === "Delivered"||order.shipment_status === "delivered"
      ).length;
      //count the total payment he/she have done for all the orders
      const totalPayment = orders.reduce((total, order) => {
        return total + order.totalPrice;
      }, 0);

      console.log("The paymentSuccessfulOrders are", paymentSuccessfulOrders);
      console.log("The deliveredOrders are", deliveredOrders);
      console.log("The totalPayment are", totalPayment);

      // Respond with the counts
      res.status(200).json({
        success: true,
        totalOrders,
        paymentSuccessfulOrders,
        deliveredOrders,
        totalPayment
      });
    } catch (error) {
      return next(new ErrorHandler(error.message, 500));
    }
  })
);


// get all orders of seller
router.get(
  "/get-seller-all-orders/:shopId",
  catchAsyncErrors(async (req, res, next) => {
    try {
      const orders = await Order.find({
        "cart.shopId": req.params.shopId,
      }).sort({
        createdAt: -1,
      });

      res.status(200).json({
        success: true,
        orders,
      });
    } catch (error) {
      return next(new ErrorHandler(error.message, 500));
    }
  })
);

// update order status for seller    ---------------(product)
router.put(
  "/update-order-status/:id",
  isSeller,
  catchAsyncErrors(async (req, res, next) => {
    try {
      const order = await Order.findById(req.params.id);

      if (!order) {
        return next(new ErrorHandler("Order not found with this id", 400));
      }
      if (req.body.status === "Transferred to delivery partner") {
        order.cart.forEach(async (o) => {
          await updateOrder(o._id, o.qty);
        });
      }

      order.status = req.body.status;

      if (req.body.status === "Delivered") {
        order.deliveredAt = Date.now();
        order.paymentInfo.status = "Succeeded";
        const serviceCharge = order.totalPrice * 0.1;
        await updateSellerInfo(order.totalPrice - serviceCharge);
      }

      await order.save({ validateBeforeSave: false });

      res.status(200).json({
        success: true,
        order,
      });

      async function updateOrder(id, qty) {
        const product = await Product.findById(id);

        product.stock -= qty;
        product.sold_out += qty;

        await product.save({ validateBeforeSave: false });
      }

      async function updateSellerInfo(amount) {
        const seller = await Shop.findById(req.seller.id);

        seller.availableBalance = amount;

        await seller.save();
      }
    } catch (error) {
      return next(new ErrorHandler(error.message, 500));
    }
  })
);

// give a refund ----- user
router.put(
  "/order-refund/:id",
  catchAsyncErrors(async (req, res, next) => {
    try {
      const order = await Order.findById(req.params.id);

      if (!order) {
        return next(new ErrorHandler("Order not found with this id", 400));
      }

      order.status = req.body.status;

      await order.save({ validateBeforeSave: false });

      res.status(200).json({
        success: true,
        order,
        message: "Order Refund Request successfully!",
      });
    } catch (error) {
      return next(new ErrorHandler(error.message, 500));
    }
  })
);

// accept the refund ---- seller
router.put(
  "/order-refund-success/:id",
  isSeller,
  catchAsyncErrors(async (req, res, next) => {
    try {
      const order = await Order.findById(req.params.id);

      if (!order) {
        return next(new ErrorHandler("Order not found with this id", 400));
      }

      order.status = req.body.status;

      await order.save();

      res.status(200).json({
        success: true,
        message: "Order Refund successfull!",
      });

      if (req.body.status === "Refund Success") {
        order.cart.forEach(async (o) => {
          await updateOrder(o._id, o.qty);
        });
      }

      async function updateOrder(id, qty) {
        const product = await Product.findById(id);

        product.stock += qty;
        product.sold_out -= qty;

        await product.save({ validateBeforeSave: false });
      }
    } catch (error) {
      return next(new ErrorHandler(error.message, 500));
    }
  })
);

// all orders --- for admin
router.get(
  "/admin-all-orders",
  catchAsyncErrors(async (req, res, next) => {
    try {
      const orders = await Order.find().sort({
        deliveredAt: -1,
        createdAt: -1,
      });
      res.status(201).json({
        success: true,
        orders,
      });
    } catch (error) {
      return next(new ErrorHandler(error.message, 500));
    }
  })
);

module.exports = router;
