const express = require('express');
const axios = require('axios');
const router = express.Router();
const Product = require("../model/product");
const catchAsyncErrors = require("../middleware/catchAsyncErrors");
const ErrorHandler = require("../utils/ErrorHandler");
const generateShipRocketToken =require('../utils/generateShipRocketToken');


//api for calculate the shipping cost for product
router.post(
    "/getshippingcost/:productId",
    catchAsyncErrors(async (req, res,next) => {
      try {
        const {productId}=req.params
        console.log("the productId is",productId);
        const address=req.body;
        console.log("the address is",address);
        console.log("the country of the viewing person is",address.address.country);
        console.log(address.address.zipCode);
        const product_pickup_location=await Product.findById({_id:productId}).select('addresses')
        const pickup_location_zipcode=product_pickup_location.addresses.zipCode;
        //these are the field we fill it manually
        const delivery_postcode = address.address.zipCode;
        const weight = 0.4; 
        const shipment_value = 0; 
        const shipping_dangerous_goods = 'No'; 
        const cod = 0; 
        const pickup_postcode=pickup_location_zipcode
        console.log("the pickup postal code is",pickup_postcode)

        //store the token inside a variable
        const token = await generateShipRocketToken();
        //api url for see the shipping charges
        const url = `https://apiv2.shiprocket.in/v1/external/courier/serviceability`;
        const url2=`https://apiv2.shiprocket.in/v1/open/courier/international/rate-calculator`;
        let params;
        if(address.address.country=="India"){
         params = {
            pickup_postcode,
            delivery_postcode,
            weight,
            shipment_value,
            shipping_dangerous_goods,
            cod
        };
      } else{
         params={
          delivery_country:address.address.country,
          weight:1,
          cod:0,
          courier_ship_type:0,
          pickup_postcode:756045,
          is_international:1,
          forall:1,
          is_web:1
        }
      }
        console.log("the params is",params);
        var response;
        //if the viewing user details is india then this api will be fired
        if(address.address.country=="India"){
         response = await axios.get(url, {
            params,
            headers: {
                'Content-Type': 'application/json',
                'Authorization': `Bearer ${token}`
            } 
        });
        console.log("******",response.data.data.available_courier_companies)
        }
        
        //delivery_country=US&weight=0.5&cod=0&courier_ship_type=0&length=&breadth=&height=&pickup_postcode=751024&is_international=1&forall=1&is_web=1
        else{
          response=await axios.get(url2,{
          params,
          headers: {
            'Content-Type': 'application/json',
            'Authorization': `Bearer ${token}`
          }
        })
      }
      
        console.log("the response  is",response.data.data);
        //declare the result the var
        var result;
        if(address.address.country!="India"){
        const data=response.data.data;
        const cheapestCourierr = data.reduce((cheapest, current) => {
          const currentRate = current.rate?.total_charge || Infinity;
          const cheapestRate = cheapest.rate?.total_charge || Infinity;
    
          return currentRate < cheapestRate ? current : cheapest;
        }, data[0]);
       
    
        console.log("Cheapest courier:", cheapestCourierr);
        result=cheapestCourierr.rate;
        console.log("the result is*******",result);
      }
        
     else{   
       
const validCouriers = response.data.data.available_courier_companies.filter(
    company => typeof company.rate === 'number'
  );
  console.log("the valid couriers are",response.data.data.available_courier_companies);
  const cheapestCourier = validCouriers.sort((a, b) => a.rate - b.rate)[0];
  console.log(cheapestCourier);

  if (cheapestCourier) {
     result = {
      courier_name: cheapestCourier.courier_name,
      rate: cheapestCourier.rate,
      estimated_delivery_date: cheapestCourier.etd,
      estimated_delivery_days: cheapestCourier.estimated_delivery_days,
      courier_id:cheapestCourier. courier_company_id
     }
    }
  }
        res.status(201).json({
          success: true,
          result
          
        });
  
      } catch (error) {
         return next(new ErrorHandler(error, 400));
      }

    })
  );
module.exports=router