const mongoose = require("mongoose");

const orderSchema = new mongoose.Schema({
  cart: {
    type: Array,
    required: true,
  },
  shippingAddress: {
    type: Object,
    required: true,
  },
  user: {
    type: Object,
    required: true,
  },
  totalPrice: {
    type: Number,
    required: true,
  },
  status: {
    type: String,
    default: "created",
  },
  shipment_id:{
    type:String
  },
  shipment_status:{
    type:String
  },
  shippingemailSent: { 
    type: Boolean, 
    default: false
   },
  outfordeliverymailSent:{
    type:Boolean,
    default:false
  },
  deliveredmailSent:{
    type:Boolean,
    default:false
  },
  courier_order_id:{
    type:String
  },
  awb_code:{
    type:String
  },
  lebel:{
    type:String
  },
  paymentInfo: {
    id: {
      type: String,
    },
    status: {
      type: String,
    },
    type: {
      type: String,
    },
  },
  paidAt: {
    type: Date,
    default: Date.now(),
  },
  deliveredAt: {
    type: Date,
  },
  createdAt: {
    type: Date,
    default: Date.now(),
  },
});

module.exports = mongoose.model("Order", orderSchema);
