const multer = require("multer");
const path = require("path");

const storage = multer.diskStorage({
  destination: function (req, file, cb) {
    try {
      cb(null, path.join(__dirname, "./uploads"));
    } catch (err) {
      console.error("Error in destination function:", err);
      cb(err); // Pass the error to the callback
    }
  },
  filename: function (req, file, cb) {
    try {
      const uniqueSuffix = Date.now() + "-" + Math.round(Math.random() * 1e9);
      const filename = file.originalname.split(".")[0];
      cb(null, filename + "-" + uniqueSuffix + ".png");
    } catch (err) {
      console.error("Error in filename function:", err);
      cb(err); // Pass the error to the callback
    }
  },
});

exports.upload = multer({ storage: storage });
